//|                    Adaptation of Trend  by jaguar1637@yahoo.com  
//|-----------------------------------------------------------------|
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_color7 DarkTurquoise
#property indicator_color8 Magenta
#property  indicator_width1  2

extern int Z = 2;
extern int Z1 = 3;
extern int Z2 = 5;
extern int S =  0;
extern int S1 = -1;
extern int S2 =  0;

double HighCurrent;
double LowSlow;
double HighCurent_Z1;
double LowSlow_Z1 = 0.0;
double PivotLine1 = 0.0;
double PivotLine2 = 0.0;
double HighCurent_Z2 = 0.0;
double LowSlow_Z2 = 0.0;
double PivotLine3 = 0.0;
double PivotLine4 = 0.0;

double ValueMin;
double ValueMax;
int FlagA= 0;

double ValueMin1;
double ValueMax1;
int FlagB= 0;
string signal;

double BufferLine1[];
double BufferLine2[];

double BufferBar1[];
double BufferBar2[];
double BufferBar3[];
double BufferBar4[];

double BuySignal[];
double SellSignal[];

extern bool alertsOn      = false;
extern bool alertsMessage = true;
extern bool alertsSound   = false;
extern bool alertsEmail   = false;


int init() {
   IndicatorBuffers(8);

   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(0, BufferLine1);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1, BufferLine2);
   //SetIndexBuffer(6, BufferBar3);
   //SetIndexBuffer(7, BufferBar4);
   
   SetIndexDrawBegin(0, Z1 + 1);
   SetIndexDrawBegin(1, Z1 + 1);
   SetIndexDrawBegin(2, Z1 + 1);
   SetIndexDrawBegin(3, Z1 + 1);
   SetIndexDrawBegin(4, Z1 + 1);
   SetIndexDrawBegin(5, Z1 + 1);
   SetIndexDrawBegin(6, Z2 + 1);
   SetIndexDrawBegin(7, Z2 + 1);
   
   //SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   //SetIndexBuffer(2, BufferBar1);
   //SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   //SetIndexBuffer(3, BufferBar2);
   SetIndexStyle(4, DRAW_ARROW, STYLE_DASH, 3);
   SetIndexArrow(4, 108); // 108
   SetIndexBuffer(4, BuySignal);
   SetIndexStyle(5, DRAW_ARROW, STYLE_DASH, 3);
   SetIndexArrow(5, 108);
   SetIndexBuffer(5, SellSignal);

   SetIndexLabel(0, "NTLine1");
   SetIndexLabel(1, "NTLine2");
   SetIndexLabel(2, "NTBar1");
   SetIndexLabel(3, "NTBar2");
   SetIndexLabel(4, "NTSig1");
   SetIndexLabel(5, "NTSig2");
   SetIndexLabel(6, "NTBar3");
   SetIndexLabel(7, "NTBar4");
   
   return (0);
}

int deinit() {
   return (0);
}

int start() 
{
   int bars;
   int li_unused_0 = MarketInfo(Symbol(), MODE_DIGITS);
   if (Bars <= Z1) return (0);
   int counted_bars = IndicatorCounted();
   if (counted_bars == 0) bars = Bars - 1;
   if (counted_bars > 0) bars = Bars - counted_bars - 1;
   for (int shift = bars; shift >= 0; shift--) {
      HighCurrent = High[iHighest(NULL, 0, MODE_HIGH, Z, shift)] + S * Point;
      LowSlow = Low[iLowest(NULL, 0, MODE_LOW, Z, shift)] - S * Point;
      HighCurent_Z1 = High[iHighest(NULL, 0, MODE_HIGH, Z1, shift)] + S1 * Point;
      LowSlow_Z1 = Low[iLowest(NULL, 0, MODE_LOW, Z1, shift)] - S1 * Point;
      HighCurent_Z2 = High[iHighest(NULL, 0, MODE_HIGH, Z2, shift)] + S2 * Point;
      LowSlow_Z2 = Low[iLowest(NULL, 0, MODE_LOW, Z2, shift)] - S2 * Point;   
      
      if (Close[shift] > BufferLine1[shift + 1]) PivotLine1 = LowSlow;
      else PivotLine1 = HighCurrent;
      if (Close[shift] > BufferLine2[shift + 1]) PivotLine2 = LowSlow_Z1;
      else PivotLine2 = HighCurent_Z1;
      BufferLine1[shift] = PivotLine1;
      BufferLine2[shift] = PivotLine2;
      
      if (Close[shift] > BufferBar3[shift + 1]) PivotLine3 = LowSlow;
      else PivotLine3 = HighCurrent;
      if (Close[shift] > BufferBar4[shift + 1]) PivotLine4 = LowSlow_Z2;
      else PivotLine4 = HighCurent_Z2;
      BufferBar3[shift] = PivotLine3;
      BufferBar4[shift] = PivotLine4;     
      
      
//--------------------------------------------------------------------------   
      ValueMin = 0.0;
      ValueMax = 0.0;
      if (Close[shift] < PivotLine1 && Close[shift] < PivotLine2) {
         ValueMin = High[shift];
         ValueMax = Low[shift];
      }
      if (Close[shift] > PivotLine1 && Close[shift] > PivotLine2) {
         ValueMin = Low[shift];
         ValueMax = High[shift];
      }
      BufferBar1[shift] = ValueMin;
      BufferBar2[shift] = ValueMax;
      
      if (Close[shift] > PivotLine2 && Close[shift] > PivotLine1 && FlagA != 1) {
         BuySignal[shift] = PivotLine2;
         SellSignal[shift] = EMPTY_VALUE;
         FlagA = 1;
         signal = "LONG";
         doAlert("long");
      }
      if (Close[shift] < PivotLine2 && Close[shift] < PivotLine1 && FlagA != 2) {
         SellSignal[shift] = PivotLine2;
         BuySignal[shift] = EMPTY_VALUE;
         FlagA = 2;
         signal = "SHORT";
         doAlert("short");
      }
//--------------------------------------------------------------------------     
      ValueMin1 = 0.0;
      ValueMax1 = 0.0;
      if (Close[shift] < PivotLine3 && Close[shift] < PivotLine4) {
         ValueMin1 = High[shift];
         ValueMax1 = Low[shift];
      }
      if (Close[shift] > PivotLine3 && Close[shift] > PivotLine4) {
         ValueMin1 = Low[shift];
         ValueMax1 = High[shift];
      }
      BufferBar3[shift] = ValueMin1;
      BufferBar4[shift] = ValueMax1;
      
      if (Close[shift] > PivotLine4 && Close[shift] > PivotLine3 && FlagB != 1) {
         BuySignal[shift] = PivotLine4;
         SellSignal[shift] = EMPTY_VALUE;
         FlagB = 1;
         signal = "FAST-LONG";
         doAlert("long");
      }
      if (Close[shift] < PivotLine4 && Close[shift] < PivotLine3 && FlagB != 2) {
         SellSignal[shift] = PivotLine4;
         BuySignal[shift] = EMPTY_VALUE;
         FlagB = 2;
         signal = "FAST-SHORT";
         doAlert("short");
      }
 
   } // FOR

   IndicatorShortName("Trend_Direction_jytv2 "+signal);
   return (0);
}


void doAlert(string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
      previousAlert  = doWhat;
      previousTime   = Time[0];

      message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend: ",doWhat);
      if (alertsMessage) Comment(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Trend_Alert"),message);
      if (alertsSound)   PlaySound("alert2.wav");
   }
}

